#include <cstdio>
#include <cmath>

#include "../coco/coco.h"
#include "population.h"
#include "tournament.h"

void binary_tournament(Population & population_in,
                       Population & population_out,
                       int mu,
                       coco_random_state_t *random_generator)
{
  int n = population_out.getSize();
  int size_out = population_out.getCurrentSize();
  int i,j;

  int k = 0;
  while (k < mu && (size_out + k < n)){
    i = floor(coco_random_uniform(random_generator)*n);
    j = floor(coco_random_uniform(random_generator)*n);

    if (population_in.getFit(i) < population_in.getFit(j)) {
      for (int m = 0; m < population_out.getDim(); m++){
        population_out.setIndiv(size_out + k, m, population_in.getIndiv(i,m));
      }
    }
    else {
      for (int m = 0; m < population_out.getDim(); m++){
        population_out.setIndiv(size_out + k, m, population_in.getIndiv(j,m));
      }
    }
    k++;
  }
  population_out.setCurrenSize(size_out+k);
}
